<?php

  class mw_data_agenda extends mw_data
  {

    function list_agenda($params = array())
    { $sgbd = $this->sgbd();
      $agenda = array("list" => array(), "total" => 0);
      $query = "SELECT * FROM #--agenda";
      $WHERE = "";
      $WHERE .= (isset($params["debut"]) ? ($WHERE ? " AND" : " WHERE")." debut >= ".$this->eq($params["debut"]) : "");
      $WHERE .= (isset($params["fin"]) ? ($WHERE ? " AND" : " WHERE")." fin <= ".$this->eq($params["fin"]) : "");
      $ORDER_BY =
      ( isset($params["order_by"]) ?
          " ORDER BY ".$params["order_by"].(isset($params["order"]) ? " ".$params["order"] : " ASC")
        : ""
      );
      $query .= $WHERE.$ORDER_BY;
      $rst = $sgbd->query($query);
      if(!isset($rst)) return false;
      while($v_rst = $sgbd->fetch_assoc($rst))
      { $agenda["list"][$v_rst["id"]] = $v_rst;
        $agenda["total"]++;
      }
      $sgbd->free_result($rst);
      return $agenda;
    }

    function get_agenda($id)
    { $sgbd = $this->sgbd();
      $agenda_item = array();
      $query = "SELECT * FROM #--agenda WHERE id=".$this->eq($id);
      $rst = $sgbd->query($query);
      if(!isset($rst)) return false;
      if($v_rst = $sgbd->fetch_assoc($rst))
      { $agenda_item = $v_rst;
        $v_date_debut = explode(" ", $agenda_item["debut"]);
        if(count($v_date_debut) == 2)
        { $v_heure_debut = explode(":", $v_date_debut[1]);
          if(count($v_heure_debut) == 3)
          { $agenda_item["date_debut"] = $v_date_debut[0];
            $agenda_item["heure_debut"] = $v_heure_debut[0];
            $agenda_item["minute_debut"] = $v_heure_debut[1];
          }
        }
        $v_date_fin = explode(" ", $agenda_item["fin"]);
        if(count($v_date_fin) == 2)
        { $v_heure_fin = explode(":", $v_date_fin[1]);
          if(count($v_heure_fin) == 3)
          { $agenda_item["date_fin"] = $v_date_fin[0];
            $agenda_item["heure_fin"] = $v_heure_fin[0];
            $agenda_item["minute_fin"] = $v_heure_fin[1];
          }
        }
      }
      $sgbd->free_result($rst);
      return $agenda_item;
    }

    function add_agenda($debut, $fin, $contenu)
    { $sgbd = $this->sgbd();
      $query =
       "INSERT INTO #--agenda(debut, fin, contenu) VALUES"
      ."( ".$this->eq($debut)
      .", ".$this->eq($fin)
      .", ".$this->eq($contenu)
      .")";
      if($sgbd->query($query)) return $sgbd->insert_id();
      return false;
    }

    function set_agenda($id, $debut, $fin, $contenu)
    { $sgbd = $this->sgbd();
      $query =
       "UPDATE #--agenda SET"
      ."  debut=".$this->eq($debut)
      .", fin=".$this->eq($fin)
      .", contenu=".$this->eq($contenu)
      ." WHERE id=".$this->eq($id);
      if($sgbd->query($query)) return true;
      return false;
    }

    function del_agenda($id)
    { $sgbd = $this->sgbd();
      $query =
       "DELETE FROM #--agenda WHERE id=".$this->eq($id);
      if($sgbd->query($query)) return true;
      return false;
    }

  }

?>