<?php

  class mw_simple_agenda extends mw_plugin
  {

    function title($env)
    { return "Agenda";
    }

    function description($env)
    { return "Une demo de plugin qui ajoute un agenda";
    }

    function install($env)
    { if($env->bdd("sgbd") == "mysql")
      { $data = $env->data();
        $sgbd = $data->sgbd();
        $DATA_EXISTS = $sgbd->table_exists("#--agenda");
        if(isset($DATA_EXISTS))
        { if(!$DATA_EXISTS)
          { $sql =
             "CREATE TABLE #--agenda"
            ."( `id` int(11) NOT NULL AUTO_INCREMENT"
            .", `debut` datetime NOT NULL"
            .", `fin` datetime NOT NULL"
            .", `contenu` text NOT NULL"
            .", PRIMARY KEY (`id`)"
            .") DEFAULT CHARSET=utf8";
            if($sgbd->query($sql))
            { $sql = "INSERT INTO #--action_status(action, id_status) VALUES('agenda/admin', 1)";
              if($sgbd->query($sql))
              { return true;
              }
              else
              { $sgbd->query("DROP TABLE #--agenda");
                return "impossible d'ajouter un statut pour l'action agenda/admin";
              }
            }
            else return "imposible de creer la table #--agenda";
          }
          else return "la table #--agenda existe deja";
        }
        else return "impossible de savoir si la table #--agenda existe";
      }
      else return "ce plugin ne fonctionne qu'avec MySql";
    }

    function uninstall($env)
    { if($env->bdd("sgbd") == "mysql")
      { $data = $env->data();
        $sgbd = $data->sgbd();
        $DATA_EXISTS = $sgbd->table_exists("#--agenda");
        if(isset($DATA_EXISTS))
        { if($DATA_EXISTS)
          { if($sgbd->query("DROP TABLE #--agenda"))
            { $sgbd->query("DELETE FROM #--action_status WHERE action='agenda/admin'");
              return true;
            }
            else return "imposible de supprimer la table #--agenda";
          }
          else return "la table #--agenda n'existe pas";
        }
        else return "impossible de savoir si la table #--agenda existe";
      }
      else return "ce plugin ne fonctionne qu'avec MySql";
    }

    function init($env)
    { $env->set_link("plugins/admin/mw_simple_agenda", $env->url("agenda/admin"), "configurer");
      // ajoute un menu "Agenda" dans le menu admin
      // $env->set_link("admin/mw_simple_agenda", $env->url("agenda/admin"), "Agenda", 40);
      $env->set_link("menu_top/mw_simple_agenda", $env->url("agenda"), "Agenda", 40);
      return true;
    }

  }


?>